"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientToClientCommands = void 0;
var ClientToClientCommands = /** @class */ (function () {
    function ClientToClientCommands(protocol) {
        this.protocol = protocol;
    }
    /**
     * Subscribe to a channel. The channel is created if it does not exist already.
     * The name may consist of alphanumeric ASCII characters plus underscore, dash, dot and colon.
     */
    ClientToClientCommands.prototype.subscribe = function (channel) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "subscribe " + channel;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Unsubscribe from a channel.
     */
    ClientToClientCommands.prototype.unsubscribe = function (channel) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "unsubscribe " + channel;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Obtain a list of all channels.
     */
    ClientToClientCommands.prototype.channels = function () {
        return __awaiter(this, void 0, void 0, function () {
            var lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.protocol.sendCommand('channels')];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, lines.map(function (line) { return line.substring(9); })];
                }
            });
        });
    };
    /**
     * Reads messages for this client. Returns a Map containing the messages grouped by channel name.
     */
    ClientToClientCommands.prototype.readMessages = function () {
        return __awaiter(this, void 0, void 0, function () {
            var lines, messagesPerChannel, i, channel, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.protocol.sendCommand('readmessages')];
                    case 1:
                        lines = _a.sent();
                        messagesPerChannel = new Map();
                        for (i = 0; i < lines.length; i += 2) {
                            channel = lines[i].substring(9);
                            message = lines[i + 1].substring(9);
                            if (!messagesPerChannel.has(channel)) {
                                messagesPerChannel.set(channel, []);
                            }
                            messagesPerChannel.get(channel).push(message);
                        }
                        return [2 /*return*/, messagesPerChannel];
                }
            });
        });
    };
    /**
     * Send a message to the specified channel.
     */
    ClientToClientCommands.prototype.sendMessage = function (channel, text) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "sendmessage " + channel + " \"" + text + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return ClientToClientCommands;
}());
exports.ClientToClientCommands = ClientToClientCommands;
//# sourceMappingURL=clientToClient.js.map