"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CurrentPlaylistCommands = void 0;
var playlists_1 = require("../objects/playlists");
var CurrentPlaylistCommands = /** @class */ (function () {
    function CurrentPlaylistCommands(protocol) {
        this.protocol = protocol;
    }
    /**
     * Adds the file or directory `uri` to the playlist (directories add recursively).
     */
    CurrentPlaylistCommands.prototype.add = function (uri) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "add \"" + uri + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Adds a song to the playlist (non-recursive) and returns the song id.
     * `uri` is always a single file or URL.
     */
    CurrentPlaylistCommands.prototype.addId = function (uri, position) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "addid \"" + uri + "\"";
                        if (position !== undefined) {
                            cmd += " " + position;
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, Number(lines[0].substring(4))];
                }
            });
        });
    };
    /**
     * Clears the current playlist.
     */
    CurrentPlaylistCommands.prototype.clear = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.protocol.sendCommand('clear')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deletes a song from the playlist.
     */
    CurrentPlaylistCommands.prototype.delete = function (position) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "delete " + position;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deletes a song range from the playlist.
     */
    CurrentPlaylistCommands.prototype.deleteRange = function (start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "delete " + start + ":";
                        if (end !== undefined) {
                            cmd += end;
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deletes the song with the given songid from the playlist.
     */
    CurrentPlaylistCommands.prototype.deleteId = function (songId) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "deleteid " + songId;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Moves the song at `from` to `to` in the playlist.
     */
    CurrentPlaylistCommands.prototype.move = function (from, to) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "move " + from + " " + to;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Moves the range of songs from `start` to `end` to `to` in the playlist.
     */
    CurrentPlaylistCommands.prototype.moveRange = function (start, end, to) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "move " + start + ":" + end + " " + to;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Moves the song with the given songid to `to` the playlist.
     * If `to` is negative, it is relative to the current song in the playlist (if there is one).
     */
    CurrentPlaylistCommands.prototype.moveId = function (songId, to) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "moveid " + songId + " " + to;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Finds songs in the current playlist with strict matching.
     */
    CurrentPlaylistCommands.prototype.playlistFind = function (tag, needle) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistfind \"" + tag + "\" \"" + needle + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['file'], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })];
                }
            });
        });
    };
    /**
     * Searches case-insensitively for partial matches in the current playlist.
     */
    CurrentPlaylistCommands.prototype.playlistSearch = function (tag, needle) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistsearch \"" + tag + "\" \"" + needle + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['file'], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })];
                }
            });
        });
    };
    /**
     * Gets info for the song with the specified songid in the playlist.
     */
    CurrentPlaylistCommands.prototype.playlistId = function (songId) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistid " + songId;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, [], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })[0]];
                }
            });
        });
    };
    /**
     * Gets info for all songs or a single song in the playlist.
     */
    CurrentPlaylistCommands.prototype.playlistInfo = function (position) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = 'playlistinfo';
                        if (position !== undefined) {
                            cmd += " " + position;
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['file'], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })];
                }
            });
        });
    };
    /**
     * Gets info for a range of songs in the playlist.
     */
    CurrentPlaylistCommands.prototype.playlistRangeInfo = function (start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistinfo " + start + ":";
                        if (end !== undefined) {
                            cmd += "" + end;
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['file'], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })];
                }
            });
        });
    };
    /**
     * Displays changed songs currently in the playlist since `version`. Start and end positions
     * may be given to limit the output to changes in the given range. To detect songs that were
     * deleted at the end of the playlist, use playlistlength returned by status command.
     */
    CurrentPlaylistCommands.prototype.playlistChanges = function (version, start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "plchanges " + version;
                        if (start !== undefined) {
                            cmd += " " + start + ":";
                            if (end !== undefined) {
                                cmd += end;
                            }
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['file'], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })];
                }
            });
        });
    };
    /**
     * Displays changed songs currently in the playlist since `version`. This function only returns
     * the position and the id of the changed song, not the complete metadata. This is more
     * bandwidth efficient. To detect songs that were deleted at the end of the playlist, use
     * playlistlength returned by status command.
     */
    CurrentPlaylistCommands.prototype.playlistChangesPosId = function (version, start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "plchangesposid " + version;
                        if (start !== undefined) {
                            cmd += " " + start + ":";
                            if (end !== undefined) {
                                cmd += end;
                            }
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['cpos'], function (valueMap) { return new playlists_1.SongIdAndPosition(valueMap); })];
                }
            });
        });
    };
    /**
     * Set the priority of the specified songs. A higher priority means that it will be played
     * first when "random" mode is enabled.
     * A priority is an integer between 0 and 255. The default priority of new songs is 0.
     */
    CurrentPlaylistCommands.prototype.prio = function (priority, start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "prio " + priority + " " + start + ":" + end;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Same as prio, but address the songs with their songid.
     */
    CurrentPlaylistCommands.prototype.prioId = function (priority, songId) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "prioid " + priority + " " + songId;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Specifies the portion of the song that shall be played. `start` and `end` are offsets
     * in seconds (fractional seconds allowed); both are optional. Omitting both means "remove the
     * range, play everything". A song that is currently playing cannot be manipulated this way.
     */
    CurrentPlaylistCommands.prototype.rangeId = function (songId, start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "rangeid " + songId + " ";
                        if (start !== undefined) {
                            cmd += start;
                        }
                        cmd += ':';
                        if (end !== undefined) {
                            cmd += end;
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Shuffles the current playlist. `start` and `end` is optional and specifies a range of songs.
     */
    CurrentPlaylistCommands.prototype.shuffle = function (start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = 'shuffle';
                        if (start !== undefined) {
                            cmd += " " + start + ":";
                            if (end !== undefined) {
                                cmd += end;
                            }
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Swaps the positions of `song1` and `song2`.
     */
    CurrentPlaylistCommands.prototype.swap = function (song1, song2) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "swap " + song1 + " " + song2;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Swaps the positions of `song1` and `song2` (both songids).
     */
    CurrentPlaylistCommands.prototype.swapId = function (song1, song2) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "swapid " + song1 + " " + song2;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Adds a tag to the specified song. Editing song tags is only possible for remote songs.
     * This change is volatile: it may be overwritten by tags received from the server, and the
     * data is gone when the song gets removed from the queue.
     */
    CurrentPlaylistCommands.prototype.addTagId = function (songId, tag, value) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "addtagid " + songId + " \"" + tag + "\" \"" + value + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Removes tags from the specified song. If `tag` is not specified, then all tag values will be
     * removed. Editing song tags is only possible for remote songs.
     */
    CurrentPlaylistCommands.prototype.clearTagId = function (songId, tag) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "cleartagid " + songId;
                        if (tag) {
                            cmd += " \"" + tag + "\"";
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return CurrentPlaylistCommands;
}());
exports.CurrentPlaylistCommands = CurrentPlaylistCommands;
//# sourceMappingURL=currentPlaylist.js.map