import { MPDProtocol } from '../protocol';
import { OutputDevice } from '../objects/outputDevice';
export declare class OutputDeviceCommands {
    private protocol;
    constructor(protocol: MPDProtocol);
    /**
     * Returns information about all outputs.
     */
    outputs(): Promise<OutputDevice[]>;
    /**
     * Turns an output on.
     */
    enableOutput(id: number): Promise<void>;
    /**
     * Turns an output off.
     */
    disableOutput(id: number): Promise<void>;
    /**
     * Turns an output on or off, depending on the current state.
     */
    toggleOutput(id: number): Promise<void>;
    /**
     * Set a runtime attribute. These are specific to the output plugin, and
     * supported values are shown in the result of the `outputs` command.
     */
    outputSet(id: number, name: string, value: string): Promise<void>;
}
