"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoredPlaylistsCommands = void 0;
var playlists_1 = require("../objects/playlists");
var StoredPlaylistsCommands = /** @class */ (function () {
    function StoredPlaylistsCommands(protocol) {
        this.protocol = protocol;
    }
    /**
     * Prints a list of the playlist directory. Each playlist name comes with its last
     * modification time. To avoid problems due to clock differences between clients and the
     * server, clients should not compare this value with their local clock.
     */
    StoredPlaylistsCommands.prototype.listPlaylists = function () {
        return __awaiter(this, void 0, void 0, function () {
            var lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.protocol.sendCommand('listplaylists')];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['playlist'], function (valueMap) { return new playlists_1.StoredPlaylist(valueMap); })];
                }
            });
        });
    };
    /**
     * Lists the songs in the playlist. Playlist plugins are supported.
     */
    StoredPlaylistsCommands.prototype.listPlaylist = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "listplaylist \"" + name + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, lines.map(function (line) { return line.substring(6); })];
                }
            });
        });
    };
    /**
     * Lists the songs with metadata in the playlist. Playlist plugins are supported.
     */
    StoredPlaylistsCommands.prototype.listPlaylistInfo = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd, lines;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "listplaylistinfo \"" + name + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        lines = _a.sent();
                        return [2 /*return*/, this.protocol.parse(lines, ['file'], function (valueMap) { return new playlists_1.PlaylistItem(valueMap); })];
                }
            });
        });
    };
    /**
     * Loads the playlist into the current queue. Playlist plugins are supported.
     * A range may be specified to load only a part of the playlist.
     */
    StoredPlaylistsCommands.prototype.load = function (name, start, end) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "load \"" + name + "\"";
                        if (start !== undefined) {
                            cmd += " " + start + ":";
                            if (end !== undefined) {
                                cmd += end;
                            }
                        }
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Saves the current playlist to `name`.m3u in the playlist directory.
     */
    StoredPlaylistsCommands.prototype.save = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "save \"" + name + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Adds `uri` to the playlist `name`.m3u. `name`.m3u will be created if it does not exist.
     */
    StoredPlaylistsCommands.prototype.playlistAdd = function (name, uri) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistadd \"" + name + "\" \"" + uri + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Clears the playlist `name`.m3u.
     */
    StoredPlaylistsCommands.prototype.playlistClear = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistclear \"" + name + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Deletes `position` from the playlist `name`.m3u.
     */
    StoredPlaylistsCommands.prototype.playlistDelete = function (name, position) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistdelete \"" + name + "\" " + position;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Moves the song at position `from` in the playlist `name`.m3u to the position `to`.
     */
    StoredPlaylistsCommands.prototype.playlistMove = function (name, from, to) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "playlistmove \"" + name + "\" " + from + " " + to;
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Renames the playlist `name`.m3u to `newName`.m3u.
     */
    StoredPlaylistsCommands.prototype.rename = function (name, newName) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "rename \"" + name + "\" \"" + newName + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Removes the playlist `name`.m3u from the playlist directory.
     */
    StoredPlaylistsCommands.prototype.remove = function (name) {
        return __awaiter(this, void 0, void 0, function () {
            var cmd;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cmd = "rm \"" + name + "\"";
                        return [4 /*yield*/, this.protocol.sendCommand(cmd)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return StoredPlaylistsCommands;
}());
exports.StoredPlaylistsCommands = StoredPlaylistsCommands;
//# sourceMappingURL=storedPlaylists.js.map