"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseOptionalNumber = exports.getOptionalBoolean = exports.getOptionalDate = exports.getOptionalNumber = exports.stringStartsWith = void 0;
function stringStartsWith(str, prefix) {
    return ((str.length >= prefix.length) && (str.substring(0, prefix.length) == prefix));
}
exports.stringStartsWith = stringStartsWith;
function getOptionalNumber(valueMap, key) {
    return valueMap.has(key) ? Number(valueMap.get(key)) : undefined;
}
exports.getOptionalNumber = getOptionalNumber;
function getOptionalDate(valueMap, key) {
    return valueMap.has(key) ? new Date(valueMap.get(key)) : undefined;
}
exports.getOptionalDate = getOptionalDate;
function getOptionalBoolean(valueMap, key) {
    return valueMap.has(key) ? Boolean(Number(valueMap.get(key))) : undefined;
}
exports.getOptionalBoolean = getOptionalBoolean;
function parseOptionalNumber(num) {
    return (num !== undefined) ? Number(num) : undefined;
}
exports.parseOptionalNumber = parseOptionalNumber;
//# sourceMappingURL=util.js.map